! A program for decimating data within a 2D seismic dataset
! Input: percentage of data to be decimated
! Output: Randomly decimated data
! Author: Joseph Jennings
! Last modified: 08/12/15

 program Mis_trace

   use sep
   use random_util

   implicit none
   integer               :: n1, n2, i1, i2, nummis, seed1
   integer, allocatable  :: trnos(:)
   real                  :: percmis
   real, allocatable     :: data(:,:), maskout(:,:), rand_num(:)

   call sep_init()
   call from_history(n1,n2)
   call from_param('percmis',percmis)
   call from_param('seed', seed1)
   nummis = 0.01*percmis*n2
   allocate(data(n1,n2), maskout(n1,n2), rand_num(nummis), trnos(nummis))

   call sep_read(data)

   maskout = 0
   call init_random_seed(seed1)
   call random_number(rand_num)
   trnos = rand_num*(n2-1) + 1

   do i1 = 1,nummis
    data (:,trnos(i1)) = 0
    maskout(:,trnos(i1)) = 1
   enddo

   call sep_write(data)
   call to_history( "n1", n1, "maskout")
   call to_history( "n2", n2, "maskout")
   call sep_write(maskout, 'maskout')
   deallocate(data, maskout)

   call sep_close()
 end program Mis_trace

