! A program for interpolating with a non-stationary PEF

program Pef3d_mis

  use sep
  use mis3_mod_lv

  implicit none
  type( lv_filter3d )                          :: aa
  integer                                      :: n1, n2, n3, n123, nlag, niter, dim
  integer                                      :: padin, p1, p2
 ! integer,                allocatable          :: lag(:,:), lag1(:), lag2(:),lag3(:)
  integer                                      :: j(3), nd(3),lag(3)
  real                                         :: eps
  real,    dimension(:),               pointer :: pm, pk
  real,                   allocatable, target  :: m(:), k(:)
  logical, dimension (:),              pointer :: pknown
  logical, dimension (:), allocatable,target   :: known

  call sep_init()

  call from_param('n1', n1) 
  call from_param('n2', n2) 
  call from_param('n3', n3)

  nd(1)=n1
  nd(2)=n2
  nd(3)=n3

  call from_param("niter",niter) 
  call from_param("lag",lag)
  call from_param("j",j)
  call from_param("eps",eps)

  aa = lv_filter3d(nd, j, lag)
  
  call from_par ("padin",padin,0)

  nd(3) = nd(3) + padin


  call sep_read (aa%coef3, "filt")

  n123 = product(nd)

  p1 = padin*n1*n2+1; p2 = n123
  allocate(m(n123),k(n123), known(n123))
  m = 0.; known = .false.
  pm => m(p1:p2)
  pk => k(p1:p2)
  pknown => known(p1:p2)
  call sep_read(pm)
  pm=100000*pm 
  call sep_read(pk, "mask")
  pknown = (pk /= 0.)
 
 ! write(0,*) m

  call mis3(n1, n2, n3, niter, m, aa, known)

  call sep_write(pm)
  deallocate(m,k,known)

end program Pef3d_mis


