program Pef3d_syn

 use sep
 use solver_reg_mod  
 use lv_conv3d_f90
 use cgstep_mod
 use lv_filters_mod
 use omp_lib
 
 implicit none
 
 integer :: n1, n2, n3
 type( lv_filter3d ) :: aa 
 real, allocatable :: m(:), d(:)
 integer  :: j(3), nd(3), stat, lag(3)
 real :: eps
 real, allocatable:: rsd(:,:,:)
 
 integer :: niter, nlag
 
 
 call sep_init()
 
 call from_param('n1', n1)
 call from_param('n2', n2)
 call from_param('n3', n3)
 
 nd(1)=n1
 nd(2)=n2
 nd(3)=n3
 
 call from_param("niter",niter) 
 call from_param("lag",lag)
 call from_param("j",j)
 call from_param("eps",eps)
 
! Construct a 3D filter
 aa = lv_filter3d(nd, j, lag)

 call sep_read(aa%coef3)
 
 call conv3d_init(n1,n2,n3)
 call conv3d_init_f(aa)
 
 allocate(m(n1*n2*n3),d(n1*n2*n3))
 m=0.
 
 call random_number(d)
 d=d-sum(d)/size(d)
 
 call solver_reg(m,d, conv3d_f_op, id3d_op,cgstep,size(m), niter,eps)


 call to_history('n1', n1)
 call to_history('n2', n2)
 call to_history('n3', n3)
 call to_history('n4', 1) 
 call sep_write(m)

 call sep_close()

end program
