! A program for interpolating with a non-stationary PEF

program Pef_mis

  use sep
  use mis2_mod_lv

  implicit none
  type( lv_filter2d )                          :: aa
  integer                                      :: n1, n2, n12, nlag, niter, dim
  integer                                      :: padin, p1, p2
  integer,                allocatable          :: lagt(:,:), lag1(:), lag2(:)
  integer                                      :: j(2), nd(2)
  real                                         :: eps
  real,    dimension(:),               pointer :: pm, pk
  real,                   allocatable, target  :: m(:), k(:)
  logical, dimension (:),              pointer :: pknown
  logical, dimension (:), allocatable, target  :: known

  call sep_init()

  call from_param('n1', n1) 
  call from_param('n2', n2) 

  nd(1)=n1
  nd(2)=n2


  call from_param("niter",niter) 
  call from_param("nlag",nlag)
  call from_param("j",j)
  call from_param("eps",eps)

  allocate(lag1(nlag),lag2(nlag), lagt(2,nlag))

  call from_param("lag1",lag1)
  call from_param("lag2",lag2)

  lagt(1,:)=lag1
  lagt(2,:)=lag2

  call from_par ("padin",padin,0)

  nd(2) = nd(2) + padin

  ! Construct a filter
  aa = lv_filter2d(nd, j, lagt)

  call sep_read (aa%coef2, "filt")

  n12 = product(nd)

  p1 = padin*n1+1; p2 = n12
  allocate(m(n12),k(n12), known(n12))
  m = 0.; known = .false.
  pm => m(p1:p2)
  pk => k(p1:p2)
  pknown => known(p1:p2)
  call sep_read(pm)
  call sep_read(pk, "mask")
  pknown = (pk /= 0.)

  call mis2(n1, nd(2), niter, m, aa, known)

  call sep_write(pm)
  deallocate(m,k,known)

end program Pef_mis


