! Dot product test for lv convolution

program lv_conv1d_dp
  use lv_filters_mod
  use lv_conv1d_mod
  use sep
  
  implicit none
  real, dimension (2) :: dot1 = (/ 0., 0. /), dot2 = (/ 0., 0. /)
  type(lv_filter1d) :: aa1, aa2
  integer :: nh,  nm, nd, j
  real    , allocatable ::  d1(:), d2(:), lagr(:), m1(:),m2(:)
  real   , allocatable :: coef(:,:), coeftmp(:)
  integer, allocatable :: lag(:,:)
  integer :: i, k, ii
   real, allocatable, target :: m(:)
   type(lv_filter1d),target :: aa

  call sep_init()


  call from_history('n1', nm)
  call from_param('j'   , j, 25)
  call from_aux('lag', "n1", nh) 

  allocate(m(nm),m1(nm),m2(nm),d1(nm),d2(nm),lagr(nh), lag(1,nh))
  call sep_read(m)
  
  call sep_read(lagr,'lag')
  
  lag(1,:) = lagr
  aa1 = lv_filter1d(nm, j, nh, lag)

  aa2 = lv_filter1d(nm, j, nh, lag)
  
  allocate(coeftmp(nh*size(aa1%coef1,2)))
  
  !call sep_read(coeftmp,'coef')
  call random_number(coeftmp)
  ii = 1
  do i=1,size(aa1%coef1,2)
  	do k=1,nh
  	aa1%coef1(k,i) = coeftmp(ii)
  	ii = ii + 1
    end do
  end do

  call lv_conv1d_init_m(m)
  
  call random_number(d2)

  call lv_conv1d_m(.false., .false., aa1, d1) 
  dot1(1) = dot_product(d1, d2)
  call lv_conv1d_m( .true., .false., aa2, d2) 
  dot1(2) = dot_product(reshape(aa1%coef1,(/nh*size(aa1%coef1,2)/)), reshape(aa2%coef1,(/nh*size(aa2%coef1,2)/)))


  call lv_conv1d_m(.false., .true., aa1, d1) 
  dot2(1) = dot_product(d1, d2)
  call lv_conv1d_m( .true., .true., aa2, d2) 
  dot2(2) = dot_product(reshape(aa1%coef1,(/nh*size(aa1%coef1,2)/)), reshape(aa2%coef1,(/nh*size(aa2%coef1,2)/)))

  call lv_conv1d_close_m()
  
  write (0,*) "DP TEST - m"
  write (0,*) dot1
  write (0,*) dot2
  
  
  aa = lv_filter1d(nm, j, nh, lag)
  
  call sep_read(coeftmp,'coef')
  ii = 1
  do i=1,size(aa1%coef1,2)
  	do k=1,nh
  	aa%coef1(k,i) = coeftmp(ii)
  	ii = ii + 1
    end do
  end do
  
  call lv_conv1d_init_f(aa)
  call random_number(m1)
  call random_number(d2)
  
  call lv_conv1d_f(.false., .false., m1, d1) 
  dot1(1) = dot_product(d1, d2)
  call lv_conv1d_f( .true., .false., m2, d2) 
  dot1(2) = dot_product(m1,m2)


  call lv_conv1d_f(.false., .true., m1, d1) 
  dot2(1) = dot_product(d1, d2)
  call lv_conv1d_f( .true., .true., m2, d2) 
  dot2(2) = dot_product(m1,m2)


  call aa1%filter_close1d()
  call aa2%filter_close1d()
 
 deallocate(m,d1,d2,m1,m2)                  

  write (0,*) "DP TEST - f"
  write (0,*) dot1
  write (0,*) dot2
  

  call sep_close()
  
end program