program lv_conv1d_inv

  use sep
  use lv_filters_mod
  use lv_conv1d_mod
  
  implicit none
  type( lv_filter1d ) :: aa, g, s
  integer :: nh,  nm, nd, j, niter
  real    , allocatable ::  d(:), lagr(:), r(:), gg(:), ss(:)
  real, allocatable, target :: m(:)

  real   , allocatable :: coef(:,:), coeftmp(:)
  integer :: i
  double precision     :: sds, gdg, gds, determ, gdr, sdr, alpha, beta

  call sep_init()

  call from_history('n1', nm)
  call from_param('j'   , j, 25)
  call from_aux('lag', "n1", nh) 
  call from_param("niter",niter)
 
  
  allocate(m(nm),d(nm),r(nm), gg(nm), ss(nm),lagr(nh))
  call sep_read(m)
  
  call sep_read(lagr,'lag')
  aa = lv_filter1d(nm, j, nh)
  aa%lag = lagr
  g=aa
  s=aa
  
  call sep_read(d,'dat')

  call lv_conv_init(m)
  !call lv_conv_1d(adj, .false., aa, d)
   
  !inversion here
  
  r=-d
  aa%coef1=0.
  
 ! write(0,*) r
  
  do i=1,niter
    call lv_conv_1d(.true.,.false., g,r)
    ! write(0,*), g%coef1
    call lv_conv_1d(.false., .false., g, gg)  
    
    !!!!!!!!STEEPEST DESCENT!!!!!!!!!!
   ! alpha= - sum(dprod(r,gg))/sum(dprod(gg,gg))
   ! aa%coef1  =  aa%coef1 +  alpha*g%coef1 
   ! r=r+alpha*gg  
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
   if (i==1) then
     s%coef1=0.
     ss=0.
     beta=0.
     if ( dot_product(gg, gg) .eq. 0 ) exit
      alpha=-sum(dprod(gg,r))/sum(dprod(gg,gg))
    ! write(0,*) alpha
    else
      gdg = sum( dprod( gg, gg))   ! search plane by solving 2-by-2
      sds = sum( dprod( ss, ss))   !  G . (R - G*alfa - S*beta) = 0
      gds = sum( dprod( gg, ss))   !  S . (R - G*alfa - S*beta) = 0
      if ( gdg.eq.0. .or. sds.eq.0.) exit
      determ = gdg * sds * max (1.d0 - (gds/gdg)*(gds/sds), 1.d-12)
      gdr = - sum( dprod( gg, r)) 
      sdr = - sum( dprod( ss, r))
      alpha = ( sds * gdr - gds * sdr ) / determ
      beta = (-gds * gdr + gdg * sdr ) / determ
    !   write(0,*) "alpha=",alpha
     !   write(0,*) "beta=", beta
    end if
    s%coef1  = alpha *  g%coef1 + beta *  s%coef1            ! update solution step
  !  write(0,*), g%coef1
    ss = alpha * gg + beta * ss            ! update residual step
    aa%coef1  =  aa%coef1 +  s%coef1                          ! update solution
   ! write(0,*), a%coef1
    r = r + ss      
   ! write(0,*) "ss", sum(ss*ss)
    
    write (0,*) i,  sum(r*r)
  end do
  
  
  
  call to_history('n1', nh)
  call to_history('n2', size(aa%coef1,2))
  call sep_write(aa%coef1)

  

  call aa%filter_close1d()
  deallocate(m,d)
  call sep_close()

 
end program

