! Dot product test for 2D lv convolution 

program lv_conv2d_dp
  use lv_filters_mod
  use lv_conv2d_mod
  use sep
  
  implicit none
  real, dimension (2) :: dot1 = (/ 0., 0. /), dot2 = (/ 0., 0. /)
  type(lv_filter2d) :: aa1, aa2
 ! integer :: nh,  nm, nd
  real    , allocatable ::  d1(:,:), d2(:,:), m1(:,:),m2(:,:)
  real   , allocatable :: coef(:,:,:), coeftmp(:)
 ! integer, allocatable :: lag(:,:)
  integer :: i, k, ii
   real, allocatable, target :: m(:,:)
   type(lv_filter2d), target :: aa
     
  integer :: nd1, nd2, np, ndim
  integer, allocatable :: j(:), lag(:,:), nd(:), lag_dim(:), lagt(:,:)

  integer i1, i2, i3

  call sep_init()




  ndim = 2
  np = 4

  ! Assuming 2D filter for 2D data
  allocate(nd(ndim), j(ndim), lag(np,ndim), lagt(ndim,np), lag_dim(ndim))

  nd1 = 10
  nd2 = 10
  nd(1) = nd1
  nd(2) = nd2
  j(1)  = 3
  j(2)  = 2

  ! The first four numbers are the first coordinate (column)
  ! The last four are the second coordinate (column)
  lag = reshape([0,1,2,2,0,0,0,1], shape(lag))

  ! This could also be done inside the lv_filter_module
  lagt = transpose(lag)

  aa = lv_filter2d(nd, j, lagt)
  aa1 = lv_filter2d(nd, j, lagt)
  aa2 = lv_filter2d(nd, j, lagt)
  allocate (coeftmp(size(aa%coef2)))
  
  call random_number(coeftmp)
  
  aa%coef2=reshape(coeftmp,shape(aa%coef2))
 
  aa1%coef2=reshape(coeftmp,shape(aa1%coef2))

 ! write (0,*) size(aa%coef2)
 allocate(m(nd(1),nd(2)))
 call random_number(m)
 
! write (0,*) m

allocate(m1(nd(1),nd(2)),d1(nd(1),nd(2)),m2(nd(1),nd(2)),d2(nd(1),nd(2))) 
  
  !!!!!!!!!!!!!!!!!!!!!!!!!

  call lv_conv2d_init_m(m)
!  
  call random_number(d2)
!
  call lv_conv2d_m(.false., .false., aa1, d1) 
  dot1(1) = sum(dprod(d1, d2))
  call lv_conv2d_m( .true., .false., aa2, d2) 
  dot1(2) = sum(dprod(aa1%coef2,aa2%coef2))
!
! write(0,*) shape(aa2%coef2)
!
  call lv_conv2d_m(.false., .true., aa1, d1) 
  dot2(1) = sum(dprod(d1, d2))
  call lv_conv2d_m( .true., .true., aa2, d2) 
  dot2(2) = sum(dprod(aa1%coef2,aa2%coef2))
!
  call lv_conv2d_close_m()
!  
  write (0,*) "DP TEST - m"
  write (0,*) dot1
  write (0,*) dot2
!  
  
!  aa = lv_filter1d(nm, j, nh, lag)
!  
!  call sep_read(coeftmp,'coef')
!  ii = 1
!  do i=1,size(aa1%coef1,2)
!  	do k=1,nh
!  	aa%coef1(k,i) = coeftmp(ii)
!  	ii = ii + 1
!    end do
!  end do
  
  
  call lv_conv2d_init_f(aa)
  
  
 ! allocate(m1(nd(1),nd(2)),d1(nd(1),nd(2)),m2(nd(1),nd(2)),d2(nd(1),nd(2)))
  
  call random_number(m1)
  call random_number(d2)
  
  call lv_conv2d_f(.false., .false., m1, d1) 
  dot1(1) = sum(dprod(d1, d2))
  call lv_conv2d_f( .true., .false., m2, d2) 
  dot1(2) =sum(dprod(m1,m2))


  call lv_conv2d_f(.false., .true., m1, d1) 
  dot2(1) = sum(dprod(d1, d2))
  call lv_conv2d_f( .true., .true., m2, d2) 
  dot2(2) = sum(dprod(m1,m2))


!  call aa1%filter_close1d()
!  call aa2%filter_close1d()
 
 deallocate(m,d1,d2,m1,m2)                  

  write (0,*) "DP TEST - f"
  write (0,*) dot1
  write (0,*) dot2
  

  call sep_close()
  
end program
