! Dot product test for 3D lv convolution 

program lv_conv3d_dp
  use lv_filters_mod
  use lv_conv3d_mod
  use sep
  use omp_lib
  
  implicit none
  real, dimension (2) :: dot1 = (/ 0., 0. /), dot2 = (/ 0., 0. /)
  type(lv_filter3d) :: aa1, aa2
  real   , allocatable ::  d1(:,:,:), d2(:,:,:), m1(:,:,:),m2(:,:,:)
  real   , allocatable :: coef(:,:,:,:), coeftmp(:)

  integer :: i, k, ii
  real, allocatable, target :: m(:,:,:)
  type(lv_filter3d), target :: aa
     
  integer :: nd1, nd2, nd3, nlag, ndim
  integer, allocatable :: j(:), lag(:), nd(:)

  integer :: i1, i2, i3

  call sep_init()

  ndim = 3
  nlag = 4

  ! Assuming 2D filter for 2D data
  allocate(nd(ndim), j(ndim), lag(ndim))

  nd1 = 100
  nd2 = 100
  nd3 = 100
  nd(1) = nd1
  nd(2) = nd2
  nd(3) = nd3
  j(1)  = 10
  j(2)  = 10
  j(3)  = 10

  ! The first four numbers are the first coordinate (column)
  ! The last four are the second coordinate (column)
  lag = (/4,3,2/)

  ! This could also be done inside the lv_filter_module


  ! This could also be done inside the lv_filter_module

  aa = lv_filter3d(nd, j, lag)
  aa1 = lv_filter3d(nd, j, lag)
  aa2 = lv_filter3d(nd, j, lag)

  
  call random_number(aa%coef3)
 ! write(0,*) aa%coef3
  
 ! aa%coef2=reshape(coeftmp,shape(aa%coef2))
 
 ! aa1%coef2=reshape(coeftmp,shape(aa1%coef2))

  aa1%coef3=aa%coef3	

 allocate(m(nd(1),nd(2),nd(3)))
 call random_number(m)
 
! write (0,*) m

 allocate(m1(nd(1),nd(2),nd(3)),d1(nd(1),nd(2),nd(3)), &
		  m2(nd(1),nd(2),nd(3)),d2(nd(1),nd(2),nd(3))) 
  
  !!!!!!!!!!!!!!!!!!!!!!!!!

  call lv_conv3d_init_m(m)
!  
  call random_number(d2)
!
  call lv_conv3d_m(.false., .false., aa1, d1) 
  dot1(1) = sum(dprod(d1, d2))
  call lv_conv3d_m( .true., .false., aa2, d2) 
 ! write (0,*) shape(aa2%coef3)
  dot1(2) = sum(dprod(aa1%coef3,aa2%coef3))
!
! write(0,*) shape(aa2%coef2)
!
  call lv_conv3d_m(.false., .true., aa1, d1) 
  dot2(1) = sum(dprod(d1, d2))
  call lv_conv3d_m( .true., .true., aa2, d2) 
  dot2(2) = sum(dprod(aa1%coef3,aa2%coef3))
!
  call lv_conv3d_close_m()
!  
  write (0,*) "DP TEST - m"
  write (0,*) dot1
  write (0,*) dot2
!  

  call lv_conv3d_init_f(aa)
  
  call random_number(m1)
  call random_number(d2)
  
  call lv_conv3d_f(.false., .false., m1, d1) 
  dot1(1) = sum(dprod(d1, d2))
  call lv_conv3d_f( .true., .false., m2, d2) 
  dot1(2) =sum(dprod(m1,m2))


  call lv_conv3d_f(.false., .true., m1, d1) 
  dot2(1) = sum(dprod(d1, d2))
  call lv_conv3d_f( .true., .true., m2, d2) 
  dot2(2) = sum(dprod(m1,m2))


!  call aa1%filter_close1d()
!  call aa2%filter_close1d()
 
 deallocate(m,d1,d2,m1,m2)                  

  write (0,*) "DP TEST - f"
  write (0,*) dot1
  write (0,*) dot2
  

  call sep_close()
  
end program
