! A toy main program for testing 1D time-variant convolution
! Author: Joe Jennings
! Last modified: 7-16-2015
program lv_filters_conv1d_main

  use lv_filters_mod
  use lv_conv1d_mod
  use sep

  implicit none
  type( lv_filter1d ) :: aa
  integer :: nh,  nm, nd, j
  real    , pointer ::  d(:), lagr(:)
  real, allocatable, target :: m(:)
  logical adj
  
  real   , allocatable :: coef(:,:), coeftmp(:)
  integer, allocatable :: lag(:,:)
  integer :: i, k, ii

  call sep_init()

  call from_param('adj' , adj, .FALSE.)
  call from_history('n1', nm)
  call from_param('j'   , j, 25)
  call from_aux('lag', "n1", nh) 

  allocate(m(nm),d(nm),lagr(nh), lag(1,nh))
  call sep_read(m)
  
  call sep_read(lagr,'lag')
  
  lag(1,:) = lagr
  aa = lv_filter1d(nm, j, nh, lag)
  !write(0,*) "lag= ", aa%lag
  !write(0,*) "b= ", aa%b
  !write(0,*) "e= ", aa%e

  if (adj) then
    call sep_read(d,'dat')
    aa%coef1 = 0.
  else
    allocate(coeftmp(nh*size(aa%coef1,2)))
    call sep_read(coeftmp,'coef')
    ii = 1
    do i=1,size(aa%coef1,2)
      do k=1,nh
        aa%coef1(k,i) = coeftmp(ii)
        ii = ii + 1
      end do
    end do
  endif

  call lv_conv1d_init_m(m)
  call lv_conv1d_m(adj, .false., aa, d)
   
  if (adj) then
  call to_history('n1', nh)
  call to_history('n2', size(aa%coef1,2))
  call sep_write(aa%coef1)
  else
  call to_history('n1', nm)
  call sep_write(d)
  end if

  call aa%filter_close1d()
  deallocate(m,d)
  call sep_close()

end program lv_filters_conv1d_main
