! A toy main program for testing 2D time-variant convolution
! Author: Joe Jennings
program lv_filters_conv3d_main
  
  use lv_filters_mod
  use sep

  implicit none
  type( lv_filter3d ) :: aa
  integer :: nd1, nd2, nd3, np, ndim,lag(3)
  integer, allocatable :: j(:),  nd(:), lag_dim(:)

  integer i1, i2, i3

  ndim = 3
  np = 4

  ! Assuming 2D filter for 2D data
  allocate(nd(ndim), j(ndim), lag_dim(ndim))

  nd1 = 10
  nd2 = 10
  nd3 = 10
  nd(1) = nd1
  nd(2) = nd2
  nd(3) = nd3
  j(1)  = 5
  j(2)  = 5
  j(3)  = 5

  ! The first four numbers are the first coordinate (column)
  ! The last four are the second coordinate (column)
  !lag = reshape([0,1,2,2,0,0,0,1,0,0,1,2], shape(lag))

  ! This could also be done inside the lv_filter_module
  !lagt = transpose(lag)

  lag_dim(1) = ndim
  lag_dim(2) = np
 
  lag=(/ 4,3,2 /)


  aa = lv_filter3d(nd, j, lag)
  
  !Checking for correct values
  write(0,*) "lag:"
  do i1=1,size(aa%lag,1)
    write(*,11) (aa%lag(i1,i2), i2=1,size(aa%lag,2))
  enddo

  write(0,*) " "

  write(0,*) "b:"
  do i1=1,size(aa%b,1)
    write(*,12) (aa%b(i1,i2), i2=1,size(aa%b,2))
  enddo

  write(0,*)

  write(0,*) "e:"
  do i1=1,size(aa%e,1)
    write(*,12) (aa%e(i1,i2), i2=1,size(aa%e,2))
  enddo

  11 format(4i2)
  12 format(12i2)

  deallocate(nd, j)

end program lv_filters_conv3d_main
