program lv_pef3d

 use sep
 use solver_reg_mod  
 use lv_conv3d_f90
 use lv_conv3d_mod
 use cgstep_mod
 use lv_filters_mod
 use omp_lib
 
 implicit none
 
 integer :: n1, n2, n3
 type( lv_filter3d ) :: aa 
 real, allocatable :: coef(:), d(:)
 real, allocatable,target:: m(:,:,:)
 integer  :: j(3), nd(3), stat, lag(3)
 real :: eps
 real, allocatable:: rsd(:,:,:)
 
 integer :: niter, nlag
 
 
 call sep_init()
 
 call from_history('n1', n1)
 call from_history('n2', n2)
 call from_history('n3', n3)
 
 nd(1)=n1
 nd(2)=n2
 nd(3)=n3
 
 call from_param("niter",niter) 
! call from_param("nlag",nlag)
 call from_param("j",j)
 call from_param("lag",lag)
 call from_param("eps",eps)
 
! allocate(lag1(nlag),lag2(nlag),lag3(nlag), lag(3,nlag))
 

 !call from_param("lag1",lag1)
 !call from_param("lag2",lag2)
! call from_param("lag3",lag3)
 

! lag(1,:)=lag1
! lag(2,:)=lag2
 !lag(3,:)=lag3

! Construct a 3D filter
 aa = lv_filter3d(nd, j, lag)
 aa%coef3(1,:,:,:)=1. 

 allocate(coef(size(aa%coef3)))
 coef=reshape(aa%coef3,shape(coef)) 

 allocate (m(n1,n2,n3),rsd(n1,n2,n3))
 
 call sep_read(m)
 m=100000*m 
  
! initialize conv_op
 call conv3d_init(n1,n2,n3) 
 call conv3d_init_f(aa)
 call conv3d_init_m(m)


 allocate (d(size(m)))
 d=0.
 
 !Initial residual = d
 call DK23d(.false.,.false.,coef,d)
 d=-d 

 call solver_reg(coef,d, DK3d_op, id3d_op,cgstep,size(coef), niter,eps)

 aa%coef3=reshape(coef,shape(aa%coef3)) 
 aa%coef3(1,:,:,:)=1.
 

  call to_history('n1', size(aa%coef3,1))
  call to_history('n2', size(aa%coef3,2))
  call to_history('n3', size(aa%coef3,3))
  call to_history('n4', size(aa%coef3,4))
  call sep_write(aa%coef3)

 call lv_conv3d_init_m(m)
 call lv_conv3d_m(.false.,.false., aa, rsd) 

 call to_history('n1', n1,"rsd")
 call to_history('n2', n2,"rsd")
 call to_history('n3', n3,"rsd")
 call sep_write(rsd,"rsd")

 call sep_close()

end program
