! A program for estimating the pef with
! missing data. 
! Input: 1. a file containing the positions
!        of the known points.
!        2. the data
!Output: the PEF

program lv_pef3d_mis

  use sep
  use misinput
  use solver_reg_mod
  use lv_conv3d_f90
  use lv_conv3d_mod
  use cgstep_mod
  use lv_filters_mod

  implicit none
  integer                   :: niter, nlag, n1, n2, n3, i1, i2, i3
  integer                   :: j(3), nd(3), stat, lag(3)
  real                      :: eps
  real, allocatable         :: kk(:,:,:), rsd(:,:,:), coef(:), d(:)
  real, allocatable, target :: m(:,:,:)
  logical, allocatable      :: test(:)
  type( lv_filter3d)        :: aa

  call sep_init()

  call from_history('n1', n1)
  call from_history('n2', n2)
  call from_history('n3', n3)
  
  nd(1) = n1
  nd(2) = n2
  nd(3) = n3

  call from_param("niter",niter) 
  call from_param("lag",lag)
  call from_param("j",j)
  call from_param("eps",eps)
  
  allocate(kk(n1,n2,n3), m(n1,n2,n3), rsd(n1,n2,n3))

  call sep_read  (m)
  m=100000*m 
  
  call sep_read  (kk, "maskin")

  aa = lv_filter3d(nd, j, lag)


  call find_mask3(kk,aa)
  aa%coef3 (1,:,:,:) = 1.

  allocate(coef(size(aa%coef3)))
  coef=reshape(aa%coef3,shape(coef))
  
  ! initialize conv_op
  call conv3d_init(n1,n2,n3)
  call conv3d_init_f(aa)
  call conv3d_init_m(m)
  
  allocate (d(size(m)))
  d=0.
 
  !call lv_conv2d_init_m(m)
  call DK23d(.false.,.false.,coef,d)
  ! write(0,*) "test", size(m)
  d=-d
  !     

  call solver_reg(coef,d, DK3d_op, id3d_op,cgstep,size(coef), niter,eps)

  aa%coef3=reshape(coef,shape(aa%coef3))
  aa%coef3(1,:,:,:)=1.

  call to_history('n1', size(aa%coef3,1))
  call to_history('n2', size(aa%coef3,2))
  call to_history('n3', size(aa%coef3,3))
  call to_history('n4', size(aa%coef3,4))
  call sep_write(aa%coef3)

  call lv_conv3d_init_m(m)
  call lv_conv3d_m(.false.,.false., aa, rsd)

  call to_history('n1', n1,"rsd")
  call to_history('n2', n2,"rsd")
  call to_history('n3', n3,"rsd")
  call sep_write(rsd,"rsd")

  call sep_close()
! deallocate(lag1,lag2,lag3,lag)

end program lv_pef3d_mis
