! A program for estimating the pef with
! missing data. 
! Input: 1. a file containing the positions
!        of the known points.
!        2. the data
!Output: the PEF

program lv_pef_mis

  use sep
  use misinput
  use solver_reg_mod
  use lv_conv2d_f90
  use lv_conv2d_mod
  use cgstep_mod
  use lv_filters_mod

  implicit none
  integer                   :: niter, nlag, n1, n2, i1, i2, i3
  integer, allocatable      :: lagt(:,:), lag1(:), lag2(:)
  integer                   :: j(2), nd(2), stat
  real                      :: eps
  real, allocatable         :: kk(:,:), rsd(:,:), coef(:), d(:)
  real, allocatable, target :: m(:,:)
  logical, allocatable      :: test(:)
  type( lv_filter2d)        :: aa

  call sep_init()

  call from_param('n1', n1)
  call from_param('n2', n2)

  nd(1) = n1
  nd(2) = n2

  call from_param("niter",niter) 
  call from_param("nlag",nlag)
  call from_param("j",j)
  call from_param("eps",eps)

  allocate(lag1(nlag),lag2(nlag),lagt(2,nlag))
  allocate(kk(n1,n2), m(n1,n2), rsd(n1,n2))

  call sep_read  (m)
  call sep_read  (kk, "maskin")
  call from_param("lag1",lag1)
  call from_param("lag2",lag2)
 
  lagt(1,:)=lag1
  lagt(2,:)=lag2

  aa = lv_filter2d(nd, j, lagt)

  !TODO: In order to use mask for the boundaries, I need
  !      a routine like boundn
  call find_mask2(kk,aa)
  aa%coef2 (1,:,:) = 1.

  allocate(coef(size(aa%coef2)))
  coef=reshape(aa%coef2,shape(coef))
  
  ! initialize conv_op
  call conv2d_init(n1,n2)
 
  call conv2d_init_f(aa)
 
  call conv2d_init_m(m)
  
  ! conv2d_m_op
  allocate (d(size(m)))
  d=0.
 
  !call lv_conv2d_init_m(m)
  call DK2(.false.,.false.,coef,d)
  ! write(0,*) "test", size(m)
  d=-d
  !     

  call solver_reg(coef,d, DK_op, id_op,cgstep,size(coef), niter,eps)

  aa%coef2=reshape(coef,shape(aa%coef2))
  aa%coef2(1,:,:)=1.

  call to_history('n1', size(aa%coef2,1))
  call to_history('n2', size(aa%coef2,2))
  call to_history('n3', size(aa%coef2,3))
  call sep_write(aa%coef2)

  call lv_conv2d_init_m(m)
  call lv_conv2d_m(.false.,.false., aa, rsd)

  call to_history('n1', n1,"rsd")
  call to_history('n2', n2,"rsd")
  call sep_write(rsd,"rsd")

  call sep_close()
  deallocate(lag1,lag2,lagt)

end program lv_pef_mis
