
module misinput

  use lv_conv2d_f90
  implicit none
  contains 
  subroutine find_mask1(maskin, n1, n2, flter, w)
    real, intent(in)              :: maskin(:)
    integer, intent(in)           :: n1,n2
    type (lv_filter2d)            :: flter
    real, dimension(size(maskin)) :: rr
    real, dimension(size(maskin)), intent(inout) :: w
    integer                       :: stat

    call conv2d_init_f(flter)
    call conv2d_init(n1,n2)
    flter%coef2 = 1
    stat = conv2d_f_op(.false.,.false.,maskin,rr) ! 
    flter%coef2 = 0
    where (rr > 0)
      w = 0
    end where
    
  end subroutine find_mask1

  subroutine find_mask2(maskin, flter)
    real, intent(in)   :: maskin(:,:)
    type (lv_filter2d) :: flter
    real               :: rr(size(maskin,1), size(maskin,2))

    call lv_conv2d_init_f(flter)
    flter%coef2 = 1.
    call lv_conv2d_f(.false.,.false.,maskin,rr)
    flter%coef2 = 0.
    where (rr > 0)
      flter%mis = .true.
    end where
  end subroutine find_mask2
  
    subroutine find_mask3(maskin, flter)
    real, intent(in)   :: maskin(:,:,:)
    type (lv_filter3d) :: flter

    where (maskin > 0)
      flter%mis3 = .true.
    end where
  end subroutine find_mask3

end module misinput
